from keras.saving.model_config import model_from_json
import numpy as np
import scipy.io

from datetime import datetime
import os
os.environ["KMP_DUPLICATE_LIB_OK"]="TRUE"


NN_in_out_size = 500
ylosedata = 0
x = np.array([0])
y = np.array([0])
nosignals = 5000 # ilosc wczytywanych sygnałów
# nosignals = 500 # ilosc wczytywanych sygnałów

batch_size = 10
# draw_counter_step = 100 / batch_size
draw_counter_step = 2000 / batch_size

loss_history = dict()
loss_history["loss"] = np.array([0])
loss_history["loss1"] = np.array([0])
loss_history["loss2"] = np.array([0])
loss_history["loss3"] = np.array([0])

def get_samples_from_file(filename, N_seg=500):
    # filename - nazwa pliku z datasetem
    # N_seg - dugość segmentów, na które podzielony ma być dataset
    mat = scipy.io.loadmat(filename)

    N_all = mat['N'] # liczba próbek sygnału w dataset

    no_of_segments = int(np.floor(N_all / N_seg)) # liczba segmentów, na które można podzielidź dataset
    Samples_in = []
    Samples_out = []
    n_seg = np.arange(N_seg)
    for j in range(no_of_segments):
        # wycinamy kolejne segmenty
        inner_list = mat['x_in'][0,j*N_seg + n_seg]
        Samples_in.append(inner_list)
        inner_list = mat['y_icdf_norm'][0,j*N_seg + n_seg]
        Samples_out.append(inner_list)

    return Samples_in, Samples_out


import matplotlib.pyplot as plt


# potem wybudowanie sieci czyli stworzenie ich warstw(jej wygląd zależy ode mnie)
import tensorflow as tf
from tensorflow import keras

# zmniejszona liczba warst dla uproszczenia modelu do testów
# funkcje aktywacji liniowe dla łatwiejszego obserwowania procesu zbieżności
# przy innych funkcjach aktywacji przy testach zdażało mi się uzyskiwać efekty, w których sieć się fiksowała na jednym sygnale wyjściowym niezależnym lub niewiele zależnym od wejścia
# przy liniowych funkcjach aktywacji, wyraźnie było widać przeregulowanei treningu i wzbudzanie się wyjścia sieci
# po uzyskaniu wstępnych wyników tutaj później można przejść na inne funkcje aktywacji
model = keras.Sequential(
    [
        keras.layers.Input(shape=(NN_in_out_size,)),
        keras.layers.Dense(NN_in_out_size, activation="linear"),
        # keras.layers.Dense(1024,activation=keras.activations.relu), # works with Keras < 2.6.0
        keras.layers.Dense(1024, activation="ReLU"),  # works with Keras = 2.6.0
        # keras.layers.Dropout(0.1),
        keras.layers.Dense(2048, activation="linear"),
        # keras.layers.Dense(1998,activation=tf.keras.activations.relu,name="layer1"),
        # keras.layers.Dense(1000,activation="sigmoid"),
        keras.layers.Dense(NN_in_out_size, activation="linear"),
    ]
)



import tensorflow as tf
from scipy import signal
from keras.layers import Dense, Flatten
from keras import backend as K

tf.config.run_functions_eagerly(False)

plt.ion()

fig = plt.figure("psd+signals")
fig2 = plt.figure("hist")
axs = fig.subplots(4)
axs2 = fig2.subplots(2)
plt. subplots_adjust()
fig3 = plt.figure("loss")

draw_counter = 0
draw_counter2 = 0

newlist = [int(x*(nosignals/80)) for x in range(4*nosignals) if x%10 == 0]
print(newlist)
ax = fig3.add_subplot(111)
ax.set_xlim(0,4*nosignals)
ax.set_ylim(0,4)
ax.set_xticklabels(newlist)
line1, = ax.plot(x, y, 'k-', alpha = 0.75,linewidth=0.5)
line2, = ax.plot(x, y, 'r-', alpha = 0.75,linewidth=0.5)
line3, = ax.plot(x, y, 'g-', alpha = 0.75,linewidth=0.5)
line4, = ax.plot(x, y, 'b-', alpha = 0.75,linewidth=0.5)

plt.show()


def update_line(fig3, new_data, ylosedata):
    global x, y, fig, line1, ax
    x = np.append(x, ylosedata)
    y = np.append(y, new_data)
    line1.set_data(x,y)
    ax.autoscale_view()
    fig.canvas.draw()

def update_line2(loss_history):
    global fig, line1, line2, line3, line4, ax
    line1.set_data(range(len(loss_history["loss"])), loss_history["loss"])
    line2.set_data(range(len(loss_history["loss1"])), loss_history["loss1"])
    line3.set_data(range(len(loss_history["loss2"])), loss_history["loss2"])
    line4.set_data(range(len(loss_history["loss3"])), loss_history["loss3"])
    ax.autoscale_view()
    fig.canvas.draw()


def my_loss(y_true, y_pred, K_psd, granted_psd, xdata,ydata, alfa, beta):
    std_all = np.zeros((len(y_pred), 1))

    global draw_counter
    # global K_psd

    if draw_counter % draw_counter_step == 0:
        axs[0].clear()
        axs[1].clear()
        axs[2].clear()
        # axs[3].clear()

    for k, y in enumerate(y_pred):
        f2, psd2 = signal.welch(y, window=signal.get_window('boxcar', int(K_psd/2)), nfft=K_psd, scaling='density')
        psd2 = 0.5 * psd2 # correct vs Matlab pwelch
        f, psd = signal.welch(y_true[k], window=signal.get_window('boxcar', int(K_psd/2)), nfft=K_psd, scaling='density')
        psd = 0.5 * psd # correct vs Matlab pwelch

        # return keras.losses.MSE(psd, psd2)
        if draw_counter % draw_counter_step == 0:
            # plt.plot(y)
            # plt.show()
            axs[0].axis(ymin=0, ymax=20.0)
            axs[0].plot(psd2)
            axs[0].plot(psd)
            axs[0].plot(granted_psd)
            axs[1].plot(y)  # generowany sygnał
            axs[2].plot(y_true[k])  # zakładany sygnał

            hist1 = axs2[0].hist(y_pred,bins=xdata,
                                range = [ydata.min(),ydata.max()],
                                density = True,
                                histtype = 'bar', alpha = 0.75)
            hist2 = axs2[1].hist(y_true,bins=xdata,
                                range=[ydata.min(), ydata.max()],
                                density=True,
                                histtype = 'bar',alpha = 0.75)

        std_all[k] = np.std(psd2 - granted_psd)

        hist1 = np.histogram(y_pred,bins=xdata,
                             range = [ydata.min(),ydata.max()],
                             density = True)
        loss3 = np.std(hist1[0] - ydata)



    loss_fnc_1 = tf.keras.losses.MeanSquaredError(reduction=tf.keras.losses.Reduction.SUM)
    loss1 = loss_fnc_1(y_true, y_pred)
    loss2 = std_all

    fig2.show()
    fig2.canvas.flush_events()
    # loss = 1.0*loss1 + 0.0*loss2
    loss = alfa * loss1 + (1 - alfa) * beta * loss2 + (1-alfa) * (1-beta) * loss3

    draw_counter = draw_counter + 1

    return loss

def get_MSE(error_array):
    return np.square(error_array).mean()

def scheduler(epoch, lr):
     if ind < 25:
        return lr
     else:
        # if ind%1250==0 :
        #     NN_in_out_size = NN_in_out_size*2
        if ind%375==0:
            lr = lr * 0.8
        return lr

def my_loss2(y_true, y_pred, K_psd, granted_psd, granted_pdf_edges, granted_pdf, alfa, beta):
    psd_err_all = np.zeros((len(y_pred), 1))
    loss2 = np.zeros((len(y_pred), 1))
    loss3 = np.zeros((len(y_pred), 1))

    psd_loss_factor = 1/3
    pdf_loss_factor = 30

    global draw_counter
    global loss_history
    # global K_psd

    # print("my_loss2")

    for k, y in enumerate(y_pred):
        f2, psd2 = signal.welch(y, window=signal.get_window('boxcar', int(K_psd/2)), nfft=K_psd, scaling='density')
        psd2 = 0.5*psd2
        f, psd = signal.welch(y_true[k], window=signal.get_window('boxcar', int(K_psd/2)), nfft=K_psd, scaling='density')
        psd = 0.5*psd

        # return keras.losses.MSE(psd, psd2)
        if draw_counter % draw_counter_step == 0:
            axs[0].clear()
            axs[1].clear()
            axs[2].clear()
            axs[3].clear()

            axs2[0].clear()
            axs2[1].clear()

            # plt.plot(y)
            # plt.show()
            axs[0].axis(ymin=0, ymax=20.0)
            axs[0].plot(psd2)
            axs[0].plot(psd)
            axs[0].plot(granted_psd)
            axs[1].plot(y)  # generowany sygnał
            axs[2].plot(y_true[k])  # zakładany sygnał
            # print("x")
            # print(psd2.shape)
            # print(granted_psd.shape)
            # print((psd2 - granted_psd).shape)
            # print((psd2 - granted_psd))
            axs[3].plot(psd2 - granted_psd)

            granted_pdf_centers = granted_pdf_edges[0:-1]+(granted_pdf_edges[1]-granted_pdf_edges[0])/2

            hist1 = axs2[0].hist(y.numpy(),bins=granted_pdf_edges,  # y_pred reprezentuje cały batch
                                density = True,
                                histtype = 'bar', alpha = 0.75)
            axs2[0].plot(granted_pdf_centers, granted_pdf)

            hist2 = axs2[1].hist(y_true[k].numpy(),bins=xdata,  # podobnie y_true reprezentuje cały batch
                                range=[ydata.min(), ydata.max()],
                                density=True,
                                histtype = 'bar',alpha = 0.75)
            axs2[1].plot(granted_pdf_centers, granted_pdf)

        # std_all[k] = np.std(psd2 - granted_psd)
        loss2[k] = get_MSE(psd2 - granted_psd)

        hist1 = np.histogram(y.numpy(),bins=granted_pdf_edges, density = True)
        # loss3[k] = np.std(hist1[0] - granted_pdf)
        loss3[k] = get_MSE(hist1[0] - granted_pdf)



    # loss_fnc_1 = tf.keras.losses.MeanSquaredError(reduction=tf.keras.losses.Reduction.SUM)
    loss_fnc_1 = tf.keras.losses.MeanSquaredError(reduction=tf.keras.losses.Reduction.SUM_OVER_BATCH_SIZE)
    loss1 = loss_fnc_1(y_true, y_pred)

    if draw_counter % draw_counter_step == 0:
        fig.show()
        fig.canvas.flush_events()
        fig2.show()
        fig2.canvas.flush_events()

    # loss = 1.0*loss1 + 0.0*loss2
    if batch_size > 1:
        loss2 = np.mean(loss2)
        loss3 = np.mean(loss3)
    loss2 = psd_loss_factor * loss2
    loss3 = pdf_loss_factor * loss3

    loss = alfa * loss1 + (1 - alfa) * beta * loss2 + (1-alfa) * (1-beta) * loss3

    draw_counter = draw_counter + 1

    # tylko ostatni wynik w batchu
    loss_history["loss"] = np.append(loss_history["loss"], loss)
    loss_history["loss1"] = np.append(loss_history["loss1"], loss1)
    loss_history["loss2"] = np.append(loss_history["loss2"], loss2)
    loss_history["loss3"] = np.append(loss_history["loss3"], loss3)

    return loss


model.summary()
layer_name = 'layer1'


opt = keras.optimizers.RMSprop(learning_rate=0.00017)  # coś działa



# odczytaj założone widmo (psd) z pliku o indeksie 0 (zakładamy, że kolejne pliki wygenerowano dal takiego zamego założenia)
filename = f'./data/test_0.mat'
mat = scipy.io.loadmat(filename)
K_psd = mat['K_psd']
# granted_psd = mat['psd_y_icdf_norm']
granted_psd = mat['psd_ref'].flatten()

granted_pdf = mat['ref_pdf_norm'].flatten()
granted_pdf_centers = mat['ref_pdf_edges'].flatten()

xgrantedhist = mat['ydata']
ygrantedhist = mat['xdata']

xdata= xgrantedhist.flatten()
ydata= ygrantedhist.flatten()

# # loss_fcn = lambda x, y: my_loss(x, y, K_psd = K_psd, granted_psd = granted_psd, alfa=0.5) # bazuje wyłącznie na MSE pomiędzy otrzymanym wyjściem a oczekiwanym wyjściem
# loss_fcn = lambda x, y: my_loss(x, y, K_psd = K_psd, granted_psd = granted_psd,xdata=xdata
#                                 ,ydata = ydata,alfa=0.99, beta=0.99) # bazuje wyłącznie na MSE pomiędzy otrzymanym wyjściem a oczekiwanym wyjściem
loss_fcn = lambda x, y: my_loss2(x, y, K_psd = K_psd, granted_psd = granted_psd, granted_pdf_edges=granted_pdf_centers, granted_pdf = granted_pdf, 
                                 alfa=0.875, beta=0.99) # bazuje wyłącznie na MSE pomiędzy otrzymanym wyjściem a oczekiwanym wyjściem
model.compile(optimizer=opt, loss=loss_fcn, run_eagerly=True)


now = datetime.now() # current date and time
date_time_str = now.strftime("%Y_%m_%d-%H_%M_%S")

save_inds = {10, 100, 250, 500, 2000, 5000}
# wariant z generowaniem nowych danych treningowych (wczytywanych z plików) dla kolejnych epok, żeby ograniczyć problem przeuczenia sieci
# można później spróbować zwiększyć liczbę epok na zestaw, ale wstępnie kolejne epoki przy niektórych próbach nic nie zmieniały)
for ind in range(nosignals):
    filename = f'./data/test_{ind}.mat'

    Samples_in, Samples_out = get_samples_from_file(filename, N_seg=NN_in_out_size)  # do testów mniejsze zestawy (i tak będzie w kolejnej epoce nowy)
    print(nosignals-ind, 'left')
    Samples_in = np.array(Samples_in, dtype="object")
    # granted = np.zeros_like(Samples_out, dtype="object")
    granted = np.array(Samples_out, dtype="object")


    # X_train, X_test, y_train, y_test = train_test_split(Samples_in, granted, test_size=0.33,
    #                                                     )
    X_train = Samples_in
    y_train = granted


    X_train = np.asarray(X_train).astype(np.float32)
    # X_test = np.asarray(X_test).astype(np.float32)
    y_train = np.asarray(y_train).astype(np.float32)
    # y_test = np.asarray(y_test).astype(np.float32)
    callback = tf.keras.callbacks.LearningRateScheduler(scheduler)
    history = model.fit(X_train, y_train, epochs=1, batch_size=batch_size,callbacks=[callback])

    # update_line(fig3, float(history.history['loss'][0]) , ylosedata)
    update_line2(loss_history)

    fig3.show()
    # ylosedata = ylosedata + 1

    if ind+1 in save_inds:
        fig.savefig(f'próba-psd-{date_time_str}-ind_{ind+1}.png')
        fig2.savefig(f'próba-hist-{date_time_str}-ind_{ind+1}.png')

        plt.savefig(f'próba-loss-{date_time_str}-ind_{ind+1}.png')

        # serialize model to JSON
        model_json = model.to_json()
        with open(f"model-{date_time_str}-ind_{ind+1}.json", "w") as json_file:
            json_file.write(model_json)
        # serialize weights to HDF5
        model.save_weights(f"model-{date_time_str}-ind_{ind+1}.h5")
        print("Saved model to disk")

        json_file = open(f"model-{date_time_str}-ind_{ind+1}.json", 'r')
        loaded_model_json = json_file.read()
        json_file.close()
        loaded_model = model_from_json(loaded_model_json)
        # load weights into new model
        loaded_model.load_weights(f"model-{date_time_str}-ind_{ind+1}.h5")
        print("Loaded model from disk")

wait = input("Press Enter to continue.")
